<div class="loaderoverlay">
    <div class="loader-cv-spinner">
        <span class="loader-spinner"></span>
    </div>
</div>
<style>
    /* The Modal (background) */
    .modal {
        display: none;
        /* Hidden by default */
        z-index: 9999 !important;
        /* Sit on top */
        padding-top: unset !important;
        /* Location of the box */
        left: 0;
        top: 0;
        width: 100%;
        /* Full width */
        height: 100%;
        /* Full height */
        overflow: auto;
        /* Enable scroll if needed */
        background-color: rgb(0, 0, 0);
        /* Fallback color */
        background-color: rgba(0, 0, 0, 0.4);
        /* Black w/ opacity */
    }

    /* Modal Content */
    .modal-content {
        background-color: #fefefe;
        margin: auto;
        padding: 20px;
        border: 1px solid #888;
        width: 80%;
    }

    /* The Close Button */
    .close {
        color: #000;
        float: right;
        font-size: 28px;
        font-weight: bold;
    }

    .close:hover,
    .close:focus {
        color: #000;
        text-decoration: none;
        cursor: pointer;
    }

    .my-modal-content {
        width: 70%;
        height: calc(100vh - 10em);
        margin-top: 5em;
        overflow-x: hidden;
        overflow-y: scroll;
        border-radius: 20px;
    }

    .my-modal-content input,
    .my-modal-content select {
        border-color: #E1E1E1 !important;
        border-radius: 5px !important;
        color: #1D2327 !important;
        font-size: 13px !important;
        line-height: normal !important;
        font-weight: 400 !important;
        padding-top: 6px !important;
        padding-bottom: 6px !important;
    }

    .label-right label,
    .label-left-text label,
    .label-left label {
        font-size: 12px;
        color: #1D2327;
        font-weight: 500;
        font-family: 'Inter', sans-serif;
        padding-right: 2px;
    }

    .label-left-text label,
    .label-left label {
        margin-bottom: 2px;
        display: flex;
    }

    .my-modal-content .header {
        grid-template-columns: .75fr 9.25fr;
    }



    .my-modal-content .modal_img {
        max-width: 50px;
        margin: 0;
    }

    .my-modal-content .header .modal_title span {
        font-size: 18px;
        font-weight: 600;
        font-family: 'Inter', sans-serif;
    }

    .content-area-right-part>h5 {
        font-size: 16px;
        margin-top: 0;
    }

    .content-area {
        gap: 15px;
    }

    .content-area-left-part,
    .content-area-right-part {
        border: 1px solid #ECECEC;
        border-radius: 20px;
        padding: 20px 12px;
        box-sizing: border-box;
        width: 50%;
    }

    .content-area-left-part>.content-area-left {
        margin-bottom: 10px;
    }

    .my-modal-content .cta-wrap {
        display: flex;
        gap: 10px;
    }

    /* width */
    ::-webkit-scrollbar {
        width: 3px;
        height: 3px;
    }

    /* Track */
    ::-webkit-scrollbar-track {
        background: #fff;
    }

    /* Handle */
    ::-webkit-scrollbar-thumb {
        background: #d7d7d7;
    }

    /* Handle on hover */
    ::-webkit-scrollbar-thumb:hover {
        background: #555;
    }
</style>

<div class="plugins-accounts-wrapper aiform-base-ui-wrapper">
    <div class="top-header">
        <h1>Ai Form</h1>

    </div>


    <div class="plugins-accounts-info">
        <div class="left-sec-wrap">
            <div class="logo-info">
                <div class="icon-info"><?php echo $iWhitelogo; ?></div>
            </div>
            <ul>
                <li><a href="#" class="menu-link-info active" data-target="tabs-1">Ai Form </a></li>
                <input type="hidden" id="store_content_nonce" value="<?php echo wp_create_nonce('store_content_nonce'); ?>">
            </ul>
        </div>



        <div class="right-sec-wrap">
            <div class="main-content-wrap">
                <div class="main-content-info tabs active" data-tab="tabs-1">
                    <h3>Ai Form</h3>
                    <div class="content-area-info single-content-area-info">
                        <div class="left-data-info">
                            <div class="panels">
                                <div class="panel-full-body-prompt">
                                    <div class="panel-left-side-prompt">
                                        <div class="left-side-bar-heading">
                                            <h5>Category</h5>
                                            <ul id="categoryList">

                                            </ul>
                                        </div>
                                    </div>
                                    <div id="ajax-right-panel">

                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="right-data-info empty-data-info">
                        </div>
                    </div>

                </div>
                <div class="main-content-info tabs" data-tab="tabs-2">
                    <h3>Logs</h3>
                    <div class="content-area-info single-content-area-info">
                        <div class="left-data-info search-data-wrap">

                            <div class="input-data full-wid">
                                <div class="input-info">
                                    <span>Search</span>
                                    <input type="text" id="" name="0" value="">

                                </div>
                            </div>

                            <div class="save-cta-info search-cta-info">
                                <a href="#">Search</a>
                            </div>

                        </div>
                        <div class="right-data-info empty-data-info">



                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</div>
<div id="promptModal" class="modal">

    <!-- Modal content -->
    <div class="modal-content my-modal-content ">
        <span class="close">&times;</span>
        <div class="header">
            <div class="modal_img">
                <span id="img_span">
                    image here
                </span>

            </div>
            <div class="modal_title">
                <span id="title_span">
                    Title here
                </span>
            </div>
        </div>
        <hr>
        <div class="content-area">
            <div class="content-area-left-part">
                <div class="content-area-left">
                    <div class="label-left">
                    </div>
                    <div class="label-left-text" id="input-fields">

                    </div>
                </div>
                <div class="content-area-left">
                    <div class="label-left">
                        <label for="Prompt">Prompt</label>
                    </div>
                    <div class="label-left-text">
                        <?php
                        $custom_text_value = '';
                        wp_editor(
                            $custom_text_value,
                            'myTextArea',  //Editor_ID
                            array(
                                'textarea_name' => '_wporg_preview_texarea',
                                'editor_height' => 500,
                                'media_buttons' => true,
                                'wpautop' => false,
                                'quicktags' => true,
                                'tinymce' => true, // Textarea box// Textarea box
                                'textarea_class' => 'preview_textarea'
                            )
                        );
                        ?>
                    </div>
                </div>
            </div>
            <div class="content-area-right-part">
                <h5>Settings</h5>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="engine">Engine:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="engine">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="max_tokens">Max Tokens:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="max_tokens">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="temperature">Temperature:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="temperature">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="top_p">Top Of:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="top_p">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="best_of">Best Of:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="best_of">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="frequency_penalty">Frequency Penalty:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="frequency_penalty">
                    </div>
                </div>
                <div class="content-area-right">
                    <div class="label-right">
                        <label for="presence_penalty">Presence Penalty:</label>
                    </div>
                    <div class="label-right-text">
                        <input type="text" id="presence_penalty">
                    </div>
                </div>
            </div>

        </div>
        <div class="cta-wrap">
            <button id="generatePromptBase" class="btn-primary-info"> Generate </button>
            <button id="draft" class="btn-primary-info"> Draft </button>
            <button id="downloadBtn" class="btn-primary-info"> Download </button>
        </div>
    </div>
</div>



<!-- Trigger/Open The Modal -->
<button id="openModalBtn" style="display: none;">Open Modal</button>



<script>
    jQuery(document).ready(function() {
        jQuery(".loaderoverlay").fadeIn(300);
        jQuery.ajax({
            url: "<?php echo esc_attr($apiUrl); ?>get-ai-category",
            type: 'Get',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");

            },
            dataType: 'json'
        }).done(function(response) {
            if (response.result == 'Success') {
                categoryData = response.data;
                jQuery.each(categoryData, function(categoryDataindex, categoryDataObject) {
                    jQuery("#categoryList").append(jQuery("<li><input type='checkbox' id=" + categoryDataObject.key + " class='category-check-box'>" + categoryDataObject.name + "</li>"));
                });


            } else if (response.result == 'Failure') {
                alert("Something Went Wrong!!")
            }

        }).fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 400) {
                var errorMessage = jqXHR.responseJSON.message;
                alert(errorMessage);
            } else {
                // For other errors, you can display the generic error message
                alert(errorThrown);
            }
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
        });

        function getPrompt() {
            jQuery(".loaderoverlay").fadeIn(300);

            jQuery.ajax({
                url: "<?php echo esc_attr($apiUrl); ?>get-prompt-ai",
                type: 'Get',
                beforeSend: function(xhr) {
                    xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                    xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
                },
                dataType: 'json'
            }).done(function(response) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                if (response.result == 'Success') {
                    var dataPrompt = response.data;
                    var data = {
                        'action': 'aih_prompt_content',
                        'promptData': dataPrompt
                    };
                    jQuery.post(ajaxurl, data, function(response) {
                        jQuery("#ajax-right-panel").html(response);
                        promptBaseId();
                        checkBoxPrompt();
                    });

                } else if (response.result == 'Failure') {
                    alert("Something Went Wrong!!")
                }

            }).fail(function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status === 400) {
                    var errorMessage = jqXHR.responseJSON.message;
                    alert(errorMessage);
                } else {
                    // For other errors, you can display the generic error message
                    alert(errorThrown);
                }
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
            });
        }
        getPrompt();

        function checkBoxPrompt() {
            jQuery(".category-check-box").change(function() {
                var objectGranted = [];
                //jQuery("#ajax-right-panel").empty();
                if(jQuery(".category-check-box:checked").length > 0){
                    jQuery(".category-check-box:checked").each(function() {
                        objectGranted.push(jQuery(this).attr("id"));
                    });
                } else{
                    jQuery(".category-check-box").each(function() {
                        objectGranted.push(jQuery(this).attr("id"));
                    });
                }                             

                jQuery(".loaderoverlay").fadeIn(300);
                objectGranted = JSON.stringify(objectGranted);
                objectGranted = objectGranted.substring(1, objectGranted.length - 1);

                objectGranted = objectGranted.replace(/['"]/g, '')

                jQuery.ajax({
                    url: "<?php echo esc_attr($apiUrl); ?>check-box-filter-ai",
                    type: 'Post',
                    beforeSend: function(xhr) {
                        xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                        xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
                    },
                    dataType: 'json',
                    data: {
                        'category': objectGranted
                    }
                }).done(function(response) {
                    setTimeout(function() {
                        jQuery(".loaderoverlay").fadeOut(300);
                    }, 500);
                    if (response.result == 'Success') {

                        var dataPrompt = response.data;
                        var data = {
                            'action': 'aih_prompt_content',
                            'promptData': dataPrompt
                        };
                        jQuery.post(ajaxurl, data, function(response) {
                            jQuery("#ajax-right-panel").html(response);
                            promptBaseId();
                            //checkBoxPrompt();
                        });

                    } else if (response.result == 'Failure') {
                        alert("Something Went Wrong!!")
                    }

                }).fail(function(jqXHR, textStatus, errorThrown) {
                    setTimeout(function() {  jQuery(".loaderoverlay").fadeOut(300); }, 500);
                    alert(jqXHR.responseJSON.message);             
                    //getPrompt();
                    // promptBaseId();
                    //checkBoxPrompt();
                });


            });
        }
    });



    function searchPrompt() {
        var searchkeyword = jQuery("#search").val();
        if (searchkeyword == '') {
            alert("Please enter search box keyword.");
            return false;
        }
        jQuery(".loaderoverlay").fadeIn(300);

        jQuery.ajax({
            url: "<?php echo esc_attr($apiUrl); ?>search-prompt-ai",
            type: 'Post',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
            },
            dataType: 'json',
            data: {
                'searchkeyword': searchkeyword
            }
        }).done(function(response) {
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            if (response.result == 'Success') {
                jQuery("#ajax-right-panel").empty();
                var dataPrompt = response.data;
                var data = {
                    'action': 'aih_prompt_content',
                    'promptData': dataPrompt
                };
                jQuery.post(ajaxurl, data, function(response) {
                    jQuery("#ajax-right-panel").html(response);
                    promptBaseId();
                    //checkBoxPrompt();

                });

            } else if (response.result == 'Failure') {
                alert("Something Went Wrong!!")
            }

        }).fail(function(jqXHR, textStatus, errorThrown) {
            alert('FAILED! ERROR: ' + errorThrown);
        });


    }

    function promptBaseId() {

        jQuery(".promptBaseId").click(function() {
            jQuery(".loaderoverlay").fadeIn(300);
            jQuery("#title_span").empty();
            jQuery("#img_span").empty();
            jQuery("#input-fields").empty();
            jQuery("#engine").val('');
            jQuery("#max_tokens").val('');
            jQuery("#temperature").val('');
            jQuery("#frequency_penalty").val('');
            jQuery("#presence_penalty").val('');
            jQuery("#top_p").val('');
            jQuery("#best_of").val('');
            var id = jQuery(this).attr("attrId");
            jQuery.ajax({
                url: "<?php echo esc_attr($apiUrl); ?>search-by-id-ai",
                type: 'Post',
                beforeSend: function(xhr) {
                    xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                    xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
                },
                dataType: 'json',
                data: {
                    'id': id
                }
            }).done(function(response) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                if (response.result == 'Success') {
                    jQuery("#title_span").text(response.data.response[0].title);
                    jQuery("#img_span").html(response.data.response[0].icon_svg);
                    jQuery("#engine").val('gpt-3.5-turbo-instruct');
                    jQuery("#top_p").val('1');
                    jQuery("#best_of").val('1');
                    jQuery("#max_tokens").val(response.data.response[0].max_tokens)
                    jQuery("#temperature").val(response.data.response[0].temperature);
                    jQuery("#frequency_penalty").val(response.data.response[0].frequency_penalty);
                    jQuery("#presence_penalty").val(response.data.response[0].presence_penalty);
                    var fields = response.data.response[0].fields;
                    fields = jQuery.parseJSON(fields);
                    jQuery.each(fields, function(fieldsIndex, fieldsValue) {
                        console.log(fieldsValue);
                        jQuery("#input-fields").append("<label class='fieldlabel'><b>" + fieldsValue.label + "</b><div class='clearfix'></div>");
                        jQuery("#input-fields").append("<input type=" + fieldsValue.type + " id=" + fieldsValue.id + "  attrId=" + fieldsValue.label + " class='text-geneator input-field-text'><div class='clearfix'></div>");
                    });



                    jQuery("#openModalBtn").trigger('click');
                } else if (response.result == 'Failure') {
                    alert("Something Went Wrong!!")
                }

            }).fail(function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status === 400) {
                    var errorMessage = jqXHR.responseJSON.message;
                    alert(errorMessage);
                } else {
                    // For other errors, you can display the generic error message
                    alert(errorThrown);
                }
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
            });
        })
    }
</script>

<script>
    // Get the modal
    var modal = document.getElementById("promptModal");

    // Get the button that opens the modal
    var btn = document.getElementById("openModalBtn");

    // Get the <span> element that closes the modal
    var span = document.getElementsByClassName("close")[0];

    // When the user clicks the button, open the modal 
    btn.onclick = function() {
        modal.style.display = "block";
    }

    // When the user clicks on <span> (x), close the modal
    span.onclick = function() {
        modal.style.display = "none";
    }

    // When the user clicks anywhere outside of the modal, close it
    window.onclick = function(event) {
        if (event.target == modal) {
            modal.style.display = "none";
        }
    }
</script>

<script>
    jQuery("#generatePromptBase").click(function() {

        var inputField = jQuery('#input-fields input[type="text"]:first');
        if (inputField.length > 0) {
            var preview_title = inputField.val();
            // console.log('Input Field Value: ' + inputValue);
        } else {
            // console.log('Input field not found or has no value.');
        }
        if (preview_title == '') {
            alert('please enter title');
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            return false;
        }

        var engine = jQuery("#engine").val();
        var max_tokens = jQuery("#max_tokens").val()
        var temperature = jQuery("#temperature").val();
        var frequency_penalty = jQuery("#frequency_penalty").val();
        var presence_penalty = jQuery("#presence_penalty").val();
        var top_p = jQuery("#top_p").val();
        var best_of = jQuery("#best_of").val();

        if (engine == '' || max_tokens == '' || temperature == '' || frequency_penalty == '' || presence_penalty == '' || top_p == "" || best_of == "") {
            alert("All fields are required.");
            return false;
        }

        jQuery(".loaderoverlay").fadeIn(300);
        var title = [];
        var textFields = [];


        jQuery('.fieldlabel').each(
            function(index) {
                var input = jQuery(this);
                title.push(input.text());
            }
        );

        jQuery('.input-field-text:input').each(
            function(index) {
                var input = jQuery(this);
                textFields.push(input.val());
            }
        );

        var promptTextTitle = title.reduce((obj, key, index) => ({
            ...obj,
            [key]: textFields[index]
        }), {});

        var title_span = jQuery("#title_span").text();
        var prompt = title_span;

        jQuery.each(promptTextTitle, function(fieldsIndex, fieldsValue) {
            prompt += '\n' + fieldsIndex + ' ' + fieldsValue;
        });

        jQuery.ajax({
            url: "<?php echo esc_attr($apiUrl); ?>prompt-base-ai",
            type: 'Post',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
            },
            dataType: 'json',
            data: {
                'prompt': prompt,
                'model': engine,
                'maxtoken': max_tokens,
                'temperature': temperature,
                "frequency_penalty": frequency_penalty,
                "presence_penalty": presence_penalty,
                "top_p": top_p,
                "best_of": best_of
            }
        }).done(function(response) {
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);

            if (response.result == 'Success') {
                tinymce.get("myTextArea").setContent(response.data.choices[0].text);
            } else if (response.result == 'Failure') {
                alert("Something Went Wrong!!")
            }

        }).fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 400) {
                var errorMessage = jqXHR.responseJSON.message;
                alert(errorMessage);
            } else {
                // For other errors, you can display the generic error message
                alert(errorThrown);
            }
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
        });
    });
</script>

<script>
    jQuery("#draft").click(function() {
        jQuery(".loaderoverlay").fadeIn(300);
        var inputField = jQuery('#input-fields input[type="text"]:first');

        // Check if the input field exists and has a value
        if (inputField.length > 0) {
            var preview_title = inputField.val();
        } else {
            // console.log('Input field not found or has no value.');
        }
        if (preview_title == '') {
            alert('please enter title');
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            return false;
        }
        // var preview_title = 'Demo';
        var content_text = tinyMCE.get('myTextArea').getContent();
        if (content_text == "") {
            alert("Empty Textarea");
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            return false;
        }
        var nonce = jQuery('#store_content_nonce').val();

        var data = {
            'action': 'store_content_data',
            'title': preview_title,
            'content_text': content_text,
            'nonce': nonce
        };
        jQuery.post(ajaxurl, data, function(response) {

            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            alert(response.message);
            jQuery("#draft").css("display", "block");

            var responseJsonData = jQuery.parseJSON(response);
            // console.log(responseJsonData.result);
            if (responseJsonData.result == 'Success') {
                // alert("Log saved successfully.");
                jQuery(".loaderoverlay").fadeOut(300);
            } else if (responseJsonData.result == 'Failure') {
                alert("Something Went Wrong.");
                jQuery(".loaderoverlay").fadeOut(300);
            }
        });
    })
</script>

<script>
    jQuery(document).ready(function($) {
        // When the download button is clicked
        jQuery('#downloadBtn').on('click', function() {
            // Get the textarea content
            var textareaContent = tinyMCE.get('myTextArea').getContent();
            if (textareaContent == "") {
                alert("Empty Textarea");
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                return false;
            }
            var inputField = jQuery('#input-fields input[type="text"]:first');

            // Check if the input field exists and has a value
            if (inputField.length > 0) {
                var preview_title = inputField.val();
                // console.log('Input Field Value: ' + inputValue);
            } else {
                // console.log('Input field not found or has no value.');
            }
            // Create a Blob object with the textarea content
            var blob = new Blob([textareaContent], {
                type: 'text/plain'
            });

            // Create a temporary anchor element to trigger the download
            var a = document.createElement('a');
            a.href = URL.createObjectURL(blob);
            a.download = preview_title + '.txt';

            // Append the anchor element to the body and trigger the download
            document.body.appendChild(a);
            a.click();

            // Clean up the URL object after download
            URL.revokeObjectURL(a.href);
        });
    });
</script>
<script>
  jQuery(document).ready(function($) {
    // Attach a click event listener to the "Open Modal" button
    $("#openModalBtn").click(function() {
        // Make an AJAX call to fetch the settings
        $.ajax({
            url: "<?php echo esc_url($apiUrl); ?>get-setting",
            method: 'GET',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
            },
            success: function(response) {
                // Ensure that the response contains the expected data property
                if (response && response.data) {
                    // Extract data from the response object
                    var settings = response.data;
                    // Render the fetched settings in the input fields
                    renderSettings(settings);
                }
            },
            error: function(xhr, status, error) {
                // Handle errors if any
                console.error("Error fetching settings:", error);
            }
        });
    });
});

// Function to render fetched settings in the input fields
function renderSettings(settings) {
    $("#engine").val(settings.model);
    $("#max_tokens").val(settings.maxtoken);
    $("#temperature").val(settings.temperature);
    $("#top_p").val(settings.top_p);
    $("#best_of").val(settings.best_of);
    $("#frequency_penalty").val(settings.frequency_penalty);
    $("#presence_penalty").val(settings.presence_penalty);
}

</script>