<?php
if (!defined('ABSPATH')) {
    exit;
}
include(PLUGIN_DIR . 'includes/wp-global.php');
?>
<!-- Google fonts -->

<style>
    /* The Modal (background) */
    .modal {
        display: none;
        /* Hidden by default */
        position: fixed;
        /* Stay in place */
        z-index: 999999999;
        padding-top: 149px;
        left: 0;
        top: 0;
        width: 100%;
        /* Full width */
        height: 100%;
        /* Full height */
        overflow: auto;
        /* Enable scroll if needed */
        background-color: rgb(0, 0, 0);
        /* Fallback color */
        background-color: rgba(0, 0, 0, 0.4);
        /* Black w/ opacity */

    }

    /* Modal Content */
    .modal-content {
        background-color: #fefefe;
        margin: auto;
        padding: 20px;
        border: 1px solid #888;
        width: 60%;
    }

    /* The Close Button */
    .close {
        color: #aaaaaa;
        float: right;
        font-size: 28px;
        font-weight: bold;
    }

    .close:hover,
    .close:focus {
        color: #000;
        text-decoration: none;
        cursor: pointer;
    }
</style>


<div class="loaderoverlay">
    <div class="loader-cv-spinner">
        <span class="loader-spinner"></span>
    </div>
</div>
<?php
if (!defined('ABSPATH'))
    exit;

session_start();

include_once(PLUGIN_DIR . 'includes/wp-global.php');
global $wpdb, $current_user, $userStatus, $settingData, $sessionLogin;

wp_get_current_user();
$user_id = $current_user->ID;

if ($settingData) {
    $singleSettingArray = $settingData[0];
}

$modelRequest  = wp_remote_get($apiUrl. 'fetch-models?category_name=translations');
$modelResponse = wp_remote_retrieve_body( $modelRequest );
?>

<div class="plugins-accounts-wrapper audio-converter-ui-wrapper">
    <div class="top-header">
        <h1>Audio Converter</h1>
        
    </div>


    <div class="plugins-accounts-info">
        <div class="left-sec-wrap">
            <div class="logo-info">
                <div class="icon-info"><?php echo $iWhitelogo; ?></div>
            </div>
            <ul>
                <li><a href="#" class="menu-link-info active" data-target="tabs-1">Audio Converter</a></li>
                <!-- <li><a href="#" class="menu-link-info" data-target="tabs-2">Logs</a></li>
                -->

            </ul>
        </div>

        <div class="right-sec-wrap">
            <div class="main-content-wrap">
                <div class="main-content-info tabs active" data-tab="tabs-1">
                    <h3>Audio Converter</h3>
                    <div class="content-area-info single-content-area-info audio-convertor-content-area-info">
                        <div class="left-data-info">
                            <div class="panel-area">
                                <form method="post" name="uploadvideo" enctype="multipart/form-data">
                                    <div class="panel-area-content">
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                            <input type="hidden" id="aih_generated_post_nonce" value="<?php echo esc_attr( wp_create_nonce( 'aih_generated_post_nonce' ) ); ?>">
                                            <input type="hidden" id="aih_audio_post_page_nonce" value="<?php echo esc_attr(wp_create_nonce('aih_audio_post_page_nonce')); ?>">
                                            <label for="purpose"> Purpose </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <select id="purpose" name="purpose" class="generator-input-field-audio">
                                                    <option selected="" value="transcriptions">Transcription</option>
                                                    <option value="translations">Translation</option>
                                                </select>
                                            </div>
                                        </div>

                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="File">
                                                    File
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <input type="radio" class="audio-change-checked" attrVal="file" name="audio-change" value="" id="file" checked>Computer</label>
                                                <!-- <input type="radio" class="audio-change-checked" attrVal="url" name="audio-change" value="" id="url">Speech To Text</label> -->
                                                
                                                
                                                
                                            </div>

                                        </div>
                                        <div class="clearfix">
                                        </div>
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <!-- <label for="File"> 
                                                    Upload File
                                                </label> -->
                                            </div>
                                            <div class="panel-area-label-input-checked" id="file-data-id">
                                                <input type="file" class="generator-input-field-audio" name="uploadAudio" value="" name="" id="file-input" />
                                                <input type="url" name="url" class="generator-input-field-audio" id="url-input" placeholder="Example: https://domain.com/audio.mp3" style="display:none" />

                                                <button type="button" class="generate-button" id="url-input" style="display:none" onclick="runSpeechRecognition()">
                                                    <?php echo esc_attr($svgMic); ?>Speech to Text</button>
                                            </div>
                                        </div>
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="purpose">
                                                    Model:
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                   <select id="model" placeholder="Please select a model">
                                                <option value="">Select One</option>
                                                <?php
                                                if ($modelResponse) {
                                                    $modelData = json_decode($modelResponse, true);
                                                    foreach ($modelData['data'] as $key => $model) {
                                                        $selectedModel = "";
                                                        if (isset($singleSettingArray['model']) && $singleSettingArray['model'] == $model['name']) {
                                                            $selectedModel = "selected";
                                                        }
                                                        echo "<option value='" . esc_attr($model['name']) . "' " . esc_attr($selectedModel) . " >" . esc_html($model['name']) . "</option>";
                                                    }
                                                }
                                                ?>
                                            </select>
                                                </select>
                                            </div>
                                        </div>
                                        <!-- <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="purpose">
                                                    Prompt(Optional)
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <input type="text" class="generator-input-field-audio" name="prompt" id="prompt">
                                            </div>
                                        </div> -->
                                        <div class="clearfix">
                                        </div>
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="purpose">
                                                    Output Format
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <select name="format" id="format" class="generator-input-field-audio">
                                                    <option selected="" value="post">post</option>
                                                    <!-- <option value="page">page</option> -->
                                                    <option value="json">json</option>
                                                    <option value="text">text</option>
                                                    <!-- <option value="srt">srt</option>
                                                    <option value="verbose_json">verbose_json</option>
                                                    <option value="vtt">vtt</option> -->
                                                </select>
                                            </div>
                                        </div>
                                        <div class="clearfix">
                                        </div>
                                        <div class="panel-area-label-input-audio" id="titleBox">
                                            <div class="panel-area-label-audio">
                                                <label for="title">
                                                    Title
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <input type="text" class="generator-input-field-audio" name="title" id="title">
                                            </div>
                                        </div>
                                        <div class="clearfix">
                                        </div>
                                        <div class="panel-area-label-input-audio" id="categoryBox">
                                            <div class="panel-area-label-audio">
                                                <label for="purpose">
                                                    Category
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <select name="category" id="category" class="generator-input-field-audio">
                                                    <?php
                                                    $categories = get_categories();
                                                    foreach ($categories as $key => $categoriesData) {
                                                    ?>
                                                        <option value="<?php echo esc_attr($categoriesData->name); ?>"><?php echo esc_attr($categoriesData->name) ?></option>
                                                    <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="panel-area-label-input-audio" id="authorBox">
                                            <div class="panel-area-label-audio">
                                                <label for="purpose">
                                                    Author
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <select name="author" id="author" class="generator-input-field-audio">
                                                    <?php
                                                    $users = get_users();
                                                    foreach ($users as $userData) {
                                                    ?>
                                                        <option value="<?php echo  esc_attr($userData->display_name); ?>"><?php echo esc_attr($userData->display_name); ?></option>
                                                    <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="panel-area-label-input-audio" id="statusBox">
                                            <div class="panel-area-label-audio">
                                                <label for="status">
                                                    Status
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <select name="status" id="status" class="generator-input-field-audio">
                                                    <option value="draft">Draft</option>
                                                    <option value="publish">Publish</option>
                                                </select>
                                            </div>
                                        </div>
                                        <!-- <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="status">
                                                    Temperature (Optional)
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <input type="number" placeholder="Select temperature 0 or 1" class="generator-input-field-audio" max=1 min=0; value="temperature" name="Temperature" />
                                            </div>
                                        </div> -->
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                                <label for="langugae" id="language_label">
                                                    Language (Optional)
                                                </label>
                                            </div>
                                            <div class="panel-area-label-input">
                                                <?php
                                                include_once(PLUGIN_DIR . 'includes/wp-language.php');
                                                ?>
                                            </div>
                                        </div>
                                        <div class="panel-area-label-input-audio">
                                            <div class="panel-area-label-audio">
                                            </div>
                                            <div class="panel-area-label-button">
                                                <!-- <button>Submit</button> -->
                                                <!-- <input type="submit" value="Upload Image" id="submit" name="submit"> -->
                                                <input type="submit" value="Upload Audio" name="ug_submit_button" id="ug_submit_button" class="btn">
                                                <!-- <button onclick="start()" class="generate-button-audio-start">Start</button>
                                                            <button onclick="setAsDefault()" class="generate-button-audio-default">Set as Deault</button> -->
                                            </div>
                                        </div>
                                    </div>
                                </form>

                            </div>
                        </div>
                        <div class="right-data-info empty-data-info">
                        </div>
                    </div>

                </div>
                <!-- <div class="main-content-info tabs" data-tab="tabs-2">
                        <h3>Logs</h3>
                        <div class="content-area-info single-content-area-info">
                            <div class="left-data-info">                               
                                <div class="panel-area">
                                    <div class="panel-area-content-table">
                                        <table class="log-audio-table"> 
                                            <thead>
                                                <tr>
                                                    <td>Id</td>
                                                    <td>Title</td>
                                                    <td>Purpose</td>
                                                    <td>Date</td>
                                                    <td>Category</td>
                                                    <td>Author</td>
                                                    <td>Status</td>
                                                </tr>
                                            </thead>
                                            <tfoot>
                                                <tr>
                                                    <td>Id</td>
                                                    <td>Title</td>
                                                    <td>Purpose</td>
                                                    <td>Date</td>
                                                    <td>Category</td>
                                                    <td>Author</td>
                                                    <td>Status</td>
                                                </tr>
                                            </tfoot>
                                        </table>
                                    </div>
                                </div>                  
                            </div>                            
                            <div class="right-data-info empty-data-info">                                  

                            </div>                            
                        </div>                        
                    </div> -->
            </div>
        </div>

    </div>
</div>



<button id="myBtn">Open Modal</button>

<!-- The Modal -->
<div id="myModal" class="modal cus-model-content-wrap">

    <!-- Modal content -->
    <div class="modal-content cus-model-content-info">
        <span class="close">&times;</span>
        <div class="panel-area">
            <div class="input-label-prompt-play">
                <label for="title-audio">Title</label>
                <input type="text" id="title-audio" Placholder="Title Come Here">
            </div>
            <div class="input-label-prompt-play">
                <?php
                $custom_text_value = '';
                wp_editor(
                    $custom_text_value,
                    'textarea-audio-converter-result',  //Editor_ID
                    array(
                        'textarea_name' => '_wporg_preview_texarea',
                        'editor_height' => 300,
                        'media_buttons' => true,
                        'wpautop' => false,
                        'quicktags' => true,
                        'tinymce' => true // Textarea box// Textarea box
                    )
                );

                ?>
            </div>


        </div>
        <button class="saveAsPagePostPublish" pagePostAttr="post" class="generate-button">Publish as Post</button>
        <button class="saveAsPagePostPublish" pagePostAttr="page" class="generate-button">Publish as Page</button>

    </div>

</div>


<!-- Audio Logs -->
<script>
    // Audio Convertor Log Data
    jQuery(document).ready(function() {
        jQuery('#logs-tab').click(function() {
            jQuery('table tbody > tr').remove();
            var data = {
                'action': 'aih_audio_log_data_get',
            };
            jQuery.post(ajaxurl, data, function(response) {
                var responseJsonData = jQuery.parseJSON(response);
                console.log(responseJsonData.result);
                if (responseJsonData.result == 'Success') {
                    var table = '';
                    table += '<tbody>';
                    var dataObj = responseJsonData.data;
                    // console.log(responseJsonData.data);
                    jQuery.each(dataObj, function(key2, valueObj) {
                        table += "<tr>";
                        jQuery.each(valueObj, function(key, value) {
                            table += "<td>" + value + "</td>"
                        });
                        table += "</tr>";
                    });
                    table += '</table>';
                    console.log(table);
                    jQuery('.log-audio-table').append(table);
                } else if (responseJsonData.result == 'Failure') {
                    alert("Something Went Wrong!!");
                }
            });
        })

        jQuery(".saveAsPagePostPublish").click(function() {
            var attrValuePagePost = jQuery(this).attr('pagePostAttr');
            var attrValue = attrValuePagePost;
            var post_page_title = jQuery("#title-audio").val();
            var post_page_content = jQuery("#textarea-audio-converter-result").val();
            var author = jQuery("#author").val();
            var catgeory = jQuery("#category").val();
            var status = jQuery("#status").val();
            var format = jQuery("#format").val();


            if (post_page_title == '') {
                alert('Title can not empty');
                return false;
            }

            if (post_page_content == '') {
                alert("Content Can not empty");
                return false;
            }
            var data = {
                'action': 'aih_audio_post_page',
                'aih_audio_post_page_nonce': jQuery('#aih_audio_post_page_nonce').val(),
                'attrValue': attrValue,
                'post_page_title': post_page_title,
                'post_page_content': post_page_content,
                'author': author,
                'catgeory': catgeory,
                'status': status,
                'format': format
            };
            jQuery.post(ajaxurl, data, function(response) {
                var responseJsonData = jQuery.parseJSON(response);
                console.log(responseJsonData.result);
                if (responseJsonData.result == 'Success') {

                    alert("Your Post Publish Succesfully");
                } else if (responseJsonData.result == 'Failure') {
                    alert("Something Went Wrong!!");
                }
            });
        });

    })
</script>

<!-- Audio Translate -->
<script>
    jQuery(document).on('change', '#format', function() {
        var selectedFormat = jQuery(this).val();
        var hideFields = ['json', 'text', 'srt', 'verbose_json', 'vtt'];

        if (hideFields.includes(selectedFormat)) {
            jQuery('#titleBox, #categoryBox, #authorBox, #statusBox').hide();
        } else {
            jQuery('#titleBox, #categoryBox, #authorBox, #statusBox').show();
            

        }
    }).trigger('change');

    jQuery(document).ready(function() {
        jQuery("#purpose").on('change', function() {
            var fileType = jQuery(this).val();
            if ('transcriptions' === fileType) {
                jQuery("#language").show();
                jQuery("#language_label").show();
            } else if ('translations' === fileType) {
                jQuery("#language").hide();
                jQuery("#language_label").hide();
            }
        });

        jQuery("#purpose").trigger('change');
    });

    jQuery(document).on('click', '#ug_submit_button', function(e) {
        jQuery(".loaderoverlay").fadeIn(300);
        e.preventDefault();
        var title = jQuery("#title").val();
        var format = jQuery("#format").val();
        if (title === '' && format === 'post') {
            alert("Title is required for post format.");
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            return false;
        }
        var uplaodFileName = '';

        var purpose = jQuery("#purpose").val();
        var apiUrl;
        if ('transcriptions' === purpose) {
            apiUrl = "<?php echo esc_attr($apiUrl); ?>transcriptions-audio-extension";

        } else if ('translations' === purpose) {
            apiUrl = "<?php echo esc_attr($apiUrl); ?>translation-audio-extension";

        } else {
            alert("Invalid purpose selected.");
            return false;
        }


        var model = jQuery("#model").val();
        var format = jQuery("#format").val();
        var author = jQuery("#author").val();
        var category = jQuery("#category").val();
        var status = jQuery("#status").val();
        var language = jQuery("#language").val();

        if (jQuery('input[name="audio-change"]:checked').attr('attrval') === 'file') {
            if (document.getElementById("file-input").files.length == 0) {
                alert("No files Selected.");
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                return false;
            }
            var fd = new FormData();
            var file = jQuery(document).find('input[type="file"]');
            var individual_file = file[0].files[0];
            fd.append("file", individual_file);
            fd.append("model", model);
            fd.append("response_format", format);

            // Use the Fetch API to send the audio file to the API
            fetch(apiUrl, {
                    method: 'POST',
                    headers: {
                        "secertkey": "<?php echo esc_attr($secertkey); ?>",
                        "openai": "<?php echo esc_attr($openAi); ?>"
                    },
                    body: fd
                })
                .then(response => response.json())
                .then(data => {

                    jQuery.ajax({
                        url: "<?php echo esc_attr($apiUrl); ?>chat",
                        type: 'POST',
                        beforeSend: function(xhr) {
                            xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                            xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
                        },
                        dataType: 'json',
                        data: {
                            'content': "Translate this " + data.data.text + " content in " + language 
                        }
                    }).done(function(response) {

                        var title = jQuery("#title").val();
    
                        var postData = {
                            'title': title,
                            'content': response.data.choices[0].message.content,
                            'category': category,
                            'author': author,
                            'status': status,
                            'format': format
                        };
    
                        if (['json', 'text', 'srt', 'verbose_json', 'vtt'].includes(format)) {
                            setTimeout(function() {
                                jQuery(".loaderoverlay").fadeOut(300);
                            }, 500);
                            // Convert the generated content to the selected format
                            var convertedContent = ''; 
                            if (format === 'json') {
                                convertedContent = JSON.stringify(response.data.choices[0].message.content, null, 2);
                                var blob = new Blob([convertedContent], {
                                    type: 'application/json'
                                });
                            } else if (format === 'text') {
                                convertedContent = response.data.choices[0].message.content;
                                var blob = new Blob([convertedContent], {
                                    type: 'text/plain'
                                });
                            } else if (format === 'srt') {
                                // Convert to srt format
                                // ...
                            } else if (format === 'verbose_json') {
                                // Convert to verbose_json format
                                // ...
                            } else if (format === 'vtt') {
                                // Convert to vtt format
                                // ...
                            }
    
                            // Create a Blob object to download the file
                            var url = URL.createObjectURL(blob);
    
                            // Create a temporary anchor element to trigger the download
                            var a = document.createElement("a");
                            a.href = url;
                            a.download = "generated_content." + format;
                            document.body.appendChild(a);
                            a.click();
    
                            // Clean up the URL object after download
                            URL.revokeObjectURL(url);
                            // alert('File Download');
                        } else if (format === 'post' || format === 'page') {
                            // Validate title for post and page formats
                            if (title === '') {
                                alert("Please enter title here.");
                                return false;
                            }
    
                            // Use AJAX to send the postData object to your custom PHP function to create a post
                            jQuery.ajax({
                                type: 'POST',
                                url: ajaxurl,
                                data: {
                                    'action': 'aih_generated_post',
                                    aih_generated_post_nonce: jQuery('#aih_generated_post_nonce').val(),
                                    'post_data': JSON.stringify(postData)
                                },
                                success: function(response) {
                                    setTimeout(function() {
                                        jQuery(".loaderoverlay").fadeOut(300);
                                    }, 500);
                                    // console.log(response); // Output will be displayed in console.log()
                                    alert(response.message);
                                    // Do additional processing as needed based on the PHP function response
                                },
                                error: function(jqXHR, textStatus, errorThrown) {
                                    if (jqXHR.status === 400) {
                                        // Status code 400 indicates a client-side error (Bad Request)
                                        // The response JSON data can be accessed using the responseJSON property
                                        var errorMessage = jqXHR.responseJSON.message;
                                        alert('API Error: ' + errorMessage);
                                    } else {
                                        // For other errors, you can display the generic error message
                                        alert('API Error: ' + errorThrown);
                                    }
                                    setTimeout(function() {
                                        jQuery(".loaderoverlay").fadeOut(300);
                                    }, 500);
                                }                  
                            });
                        }
                    })
                })
                .catch(error => {
                    console.error('Error:', error);
                    alert("Some error occures");
                    setTimeout(function() {
                        jQuery(".loaderoverlay").fadeOut(300);
                    }, 500);
                });
        } else {
            var url_input = jQuery("#url-input").val();
            if (url_input === '') {
                alert("Please enter the URL.");
                return false;
            }
        }
    });

</script>

<!-- Modal -->
<script>
    // Get the modal
    var modal = document.getElementById("myModal");

    // Get the button that opens the modal
    var btn = document.getElementById("myBtn");

    // Get the <span> element that closes the modal
    var span = document.getElementsByClassName("close")[0];

    // When the user clicks the button, open the modal 
    btn.onclick = function() {
        modal.style.display = "block";
    }

    // When the user clicks on <span> (x), close the modal
    span.onclick = function() {
        modal.style.display = "none";
    }

    // When the user clicks anywhere outside of the modal, close it
    window.onclick = function(event) {
        if (event.target == modal) {
            modal.style.display = "none";
        }
    }
</script>