<div class="loaderoverlay">
    <div class="loader-cv-spinner">
        <span class="loader-spinner"></span>
    </div>
</div>

<!-- Google fonts -->





<style>
    /* ChatGPT Css */


    .message {
        color: #FFFFFF;
        clear: both;
        line-height: 18px;
        font-size: 15px;
        padding: 8px;
        position: relative;
        margin: 8px 0;
        max-width: 80%;
        word-wrap: break-word;


    }

    .message:after {
        position: absolute;
        /* content: ""; */
        width: 0;
        height: 0;
        border-style: solid;
    }

    .metadata {
        display: inline-block;
        /* float: right; */
        padding: 0 0 0 7px;
        position: relative;
        bottom: -4px;
    }

    .metadata .time {
        color: rgba(0, 0, 0, .45);
        font-size: 11px;
        display: inline-block;
        color: white;
    }

    .message:first-child {
        margin: 16px 0 8px;
    }


    .message.sent {
        background: #17202A;
        border-radius: 5px 0px 5px 5px;
        float: right;
        color: #FFFFFF;

    }
    .message span{
        color: #FFFFFF !important;
    }
    .message.received {
        background: #17202A;
        border-radius: 5px 0px 5px 5px;
        /* float: right; */
        color: #FFFFFF;
    }
        .message.sent:after {
        border-width: 0px 0 10px 10px;
        border-color: transparent transparent transparent #17202A;
        top: 0;
        right: -10px;
    }
</style>

<div class="plugins-accounts-wrapper chatgpt-ui-wrapper">
    <div class="top-header">
        <h1>ChatGPT</h1>
        
    </div>

    <div class="plugins-accounts-info">
        <div class="left-sec-wrap">
            <div class="logo-info">
                <div class="icon-info"><?php echo $iWhitelogo; ?></div>
            </div>
            <ul>
                <li><a href="#" class="menu-link-info active" data-target="tabs-1">ChatBot</a></li>
            </ul>
        </div>

        <div class="right-sec-wrap">
            <div class="main-content-wrap">
                <div class="main-content-info tabs active" data-tab="tabs-1">
                    <h3>ChatBot</h3>

                    <div class="full-wid-content-area-info">

                        <div class="full-wid-data-info">
                            <div class="header-chat-gpt">
                                <span id="chat-gpt-name">AI:</span>
                                <span id="chat-gpt-text">Hello human, I am a GPT powered AI chat bot. Ask me anything!</span>
                            </div>
                            <div class="chatgpt-entry-data-info Center-Block">
                                <div class="chatgpt-entry-response Center-Blocks">  
                                </div>
                                <div class="input-info" id="chat-text" class="Center-Block">
                                    <input type="text" value="" id="chat-message" placeholder="Type a message">
                                    <a href="javascript:void(0)" class="cta-info cta-mic">
                                        <!-- <i class="fa-solid fa-microphone"></i> -->
                                    </a>
                                    <a href="javascript:void(0)" onClick="chatBot()" class="cta-info">
                                        <svg width="26" height="22" viewBox="0 0 26 22" fill="none" xmlns="http://www.w3.org/2000/svg">
                                            <path d="M0.0120833 21.75L25.375 10.875L0.0120833 0L0 8.45833L18.125 10.875L0 13.2917L0.0120833 21.75Z" fill="#494949" />
                                        </svg>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<script>
    function chatBot() {
        var chatText = jQuery("#chat-message").val();
        if (chatText == '') {
            alert("Enter Chat Bot Message");
            return false;
        }

        var msgHtml = '<span class="right-chatgpt-entry-response"><div class="sent" id="sentMessagesContainer"><div class="message sent"><span id="sentMsg">' + chatText + '</span></div></div></span>';

        jQuery('.chatgpt-entry-response ').append(msgHtml);
        jQuery('#chat-message').val('');

        jQuery(".loaderoverlay").fadeIn(300);

        jQuery.ajax({
            url: "<?php echo esc_url($apiUrl); ?>chat",
            type: 'POST',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
            },
            dataType: 'json',
            data: {
                'content': chatText
            }
        }).done(function(response) {
            
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
            if (response.result == 'Success') {
                var replyMessage = response.data.choices[0].message.content;
                replyMessage = replyMessage.replaceAll(">", "&gt");
                replyMessage = replyMessage.replaceAll("<", "&lt");
                replyMessage = replyMessage.replaceAll("\n", "</br>");
                msgHtml = '<span class="left-chatgpt-entry-response"><div class="received" id="receivedMessagesContainer"><div class="message received"><span id="receiveMsg">' + replyMessage + '</span></div></div></span>';
                jQuery('.chatgpt-entry-response').append(msgHtml);

            } else if (response.result == 'Failure') {
                alert("Something Went Wrong!!")
            }


        }).fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 400) {
                // Status code 400 indicates a client-side error (Bad Request)
                // The response JSON data can be accessed using the responseJSON property
                var errorMessage = jqXHR.responseJSON.message;
                alert( errorMessage);
            } else {
                // For other errors, you can display the generic error message
                alert( errorThrown);
            }
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
        });

    }

    function botResponse() {
        const r = random(0, BOT_MSGS.length - 1);
        const msgText = BOT_MSGS[r];
        const delay = msgText.split(" ").length * 100;

        setTimeout(() => {
            appendMessage(BOT_NAME, BOT_IMG, "left", msgText);
        }, delay);
    }

    // Utils
    function get(selector, root = document) {
        return root.querySelector(selector);
    }

    function formatDate(date) {
        const h = "0" + date.getHours();
        const m = "0" + date.getMinutes();

        return `${h.slice(-2)}:${m.slice(-2)}`;
    }

    jQuery(document).ready(function(){
        jQuery('#chat-message').keypress(function(event){
            if(event.which === 13 && !event.shiftKey){
                chatBot();
            }
        });
    });

</script>