<div class="loaderoverlay">
    <div class="loader-cv-spinner">
        <span class="loader-spinner"></span>
    </div>
</div>

<!-- Google fonts -->




<!-- font awesome -->

<div class="plugins-accounts-wrapper image-generator-ui-wrapper">
    <div class="top-header">
        <h1>Image Generator</h1>
        
    </div>


    <div class="plugins-accounts-info">
        <div class="left-sec-wrap">
            <div class="logo-info">
                <div class="icon-info"><?php echo $iWhitelogo; ?></div>
            </div>
            <ul>
                <li><a href="#" class="menu-link-info active" data-target="tabs-1">DALL-E</a></li>
                <li><a href="#" class="menu-link-info" data-target="tabs-2">Stable Diffusion</a></li>
            </ul>
        </div>

        <div class="right-sec-wrap">
            <div class="main-content-wrap">
                <div class="main-content-info tabs active" data-tab="tabs-1">
                    <h3>DALL-E</h3>
                    <div class="content-area-info">
                        <div class="left-data-info search-data-wrap">

                            <div class="input-data full-wid">
                                <div class="input-info">
                                    <span>Prompt:</span>
                                    <?php  $generateRandomNumber =  wp_rand(1, $countPromptsValue);  ?>
                                    <textarea id="SupriseMeDallETextValue" rows="3" cols="5"><?php echo esc_html($promptDataArray['prompts'][--$generateRandomNumber]); ?></textarea>
                                </div>
                            </div>

                            <div class="save-cta-info search-cta-info">
                                <a href="javascript:void(0)" id="SupriseMeDALLE" class="br-blue-info1">Surprise Me</a>
                            </div>
                        </div>
                        <div class="right-data-info">
                            <div class="input-data-wrap">
                                <h4>Settings</h4>
                                <div class="input-data">
                                    <div class="label-info"><span>Size:</span></div>
                                    <div class="input-info">
                                        <select id="image-size-dall-e">
                                            <option value="256x256">256x256</option>
                                            <option value="512x512">512x512</option>
                                            <option value="1024x1024">1024x1024</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="input-data">
                                    <div class="label-info"><span># of:</span></div>
                                    <div class="input-info">
                                        <select id="image-no-dall-e">
                                            <?php
                                            for ($i = 1; $i <= 5; $i++) {
                                                echo "<option value='" . esc_attr($i) . "'>" . esc_html($i) . "</option>";
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="save-cta-info">
                                    <a href="javascript:void(0)" id="GenerateDalle" class="br-blue-info1">Generate</a>
                                </div>


                            </div>
                        </div>
                        <div class="left-data-info search-data-wrap" id="left-dall-e-image" style="display:none">
                            <div class="input-data-wrap">
                                <h4>Output</h4>
                                <div class="show-image-generator" id="show-image-generator-dall-e">

                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="main-content-info tabs" data-tab="tabs-2">
                    <h3>Stable Diffusion</h3>
                    <div class="content-area-info">
                        <div class="left-data-info search-data-wrap">

                            <div class="input-data full-wid">
                                <div class="input-info">
                                    <span>Prompt:</span>
                                    <?php  $generateRandomNumber =  wp_rand(1, $countPromptsValue);  ?>
                                    <textarea id="StableDiffusionTextValue" rows="3" cols="5"><?php echo esc_textarea($promptDataArray['prompts'][--$generateRandomNumber]); ?></textarea>
                                    </div>
                            </div>
                            <div class="save-cta-info search-cta-info">
                                <a href="javascript:void(0)" id="supriseMeStable" class="br-blue-info">Surprise Me</a>

                            </div>

                        </div>
                        <div class="right-data-info">
                            <div class="input-data-wrap">
                                <h4>Settings</h4>
                                <div class="input-data">
                                    <div class="label-info"><span>Size:</span></div>
                                    <div class="input-info">
                                        <select id="image-size-stable-diffusion">
                                            <option value="256x256">256x256</option>
                                            <option value="512x512">512x512</option>
                                            <option value="1024x1024">1024x1024</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="input-data">
                                    <div class="label-info"><span># of:</span></div>
                                    <div class="input-info">
                                        <select id="image-n-stable-diffusion">
                                            <?php
                                            for ($i = 1; $i <= 5; $i++) {
                                                echo "<option value='" . esc_attr($i) . "'>" . esc_html($i) . "</option>";
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="save-cta-info">
                                    <a href="javascript:void(0)" id="GenerateStable" class="br-blue-info">Generate</a>
                                </div>
                            </div>
                        </div>
                        <div class="left-data-info search-data-wrap" id="left-stable-e-image" style="display:none">
                            <div class="input-data-wrap">
                                <h4>Output</h4>
                                <div class="show-image-generator" id="show-image-generator-stable-e">

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</div>

<script type="text/javascript">
    jQuery('.menu-link-info').on('click', function(e) {
        e.preventDefault();
        jQuery('.menu-link-info').removeClass('active');
        jQuery(this).addClass('active');
        jQuery('.tabs').removeClass('active');
        var tabID = jQuery(this).attr('data-target');
        jQuery('.tabs[data-tab="' + tabID + '"]').addClass('active');
    });
</script>

<!-- accordion-menus -->
<script>
    var acc = document.getElementsByClassName("accordionmenu");
    var panel = document.getElementsByClassName('am-panel');

    for (var i = 0; i < acc.length; i++) {
        acc[i].onclick = function() {
            var setClasses = !this.classList.contains('activeam');
            setClass(acc, 'activeam', 'remove');
            setClass(panel, 'showam', 'remove');

            if (setClasses) {
                this.classList.toggle("activeam");
                this.nextElementSibling.classList.toggle("showam");
            }
        }
    }

    function setClass(els, className, fnName) {
        for (var i = 0; i < els.length; i++) {
            els[i].classList[fnName](className);
        }
    }
</script>

<script>
    jQuery(document).ready(function() {
        jQuery("#supriseMeStable").click(function() {
            jQuery(".loaderoverlay").fadeIn(300);
            jQuery("#StableDiffusionTextValue").val('');
            jQuery.getJSON("<?php echo esc_url(get_site_url()) . '/wp-content/plugins/AI-HarnessV2/json/prompt.json'; ?>", function(data) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                const totalNumberOfElement = (data.prompts).length;
                const startNumberOfElement = 1;
                var randomNumberSelection = Math.floor(Math.random() * (totalNumberOfElement - startNumberOfElement + 1) + startNumberOfElement)
                jQuery("#StableDiffusionTextValue").val(data.prompts[--randomNumberSelection]);
            });
        });
        jQuery("#SupriseMeDALLE").click(function() {
            jQuery(".loaderoverlay").fadeIn(300);
            jQuery("#SupriseMeDallETextValue").val('');
            jQuery.getJSON("<?php echo esc_url(get_site_url()) . '/wp-content/plugins/AI-HarnessV2/json/prompt.json'; ?>", function(data) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                const totalNumberOfElement = (data.prompts).length;
                const startNumberOfElement = 1;
                var randomNumberSelection = Math.floor(Math.random() * (totalNumberOfElement - startNumberOfElement + 1) + startNumberOfElement)
                jQuery("#SupriseMeDallETextValue").val(data.prompts[--randomNumberSelection]);
            });
        })
    })

    jQuery("#GenerateDalle").click(function() {
        var prompt = jQuery("#SupriseMeDallETextValue").val();
        var size = jQuery("#image-size-dall-e").val();
        var n = parseInt(jQuery("#image-no-dall-e").val());
        var openAiKey = "<?php echo esc_attr($openAi); ?>";
        var secretiKey = "<?php echo esc_attr($secertkey); ?>";
        if (prompt == '') {
            alert("Enter Image Title");
            return false;
        }
        if (openAiKey == '') {
            alert("OpenAi Key missing");
            return false;
        }
        if (secretiKey == '') {
            alert("Secret Key missing");
            return false;
        }
        jQuery('#show-image-generator-dall-e').empty();
        jQuery(".loaderoverlay").fadeIn(300);
        jQuery.ajax({
            url: "<?php echo esc_attr($apiUrl); ?>generate-image",
            type: 'POST',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", secretiKey);
                xhr.setRequestHeader("openai", openAiKey);
            },
            dataType: 'json',
            data: {
                'prompt': prompt,
                'n': n,
                'size': size
            }
        }).done(function(response) {

            if (response.result == 'Success') {
                var images = response.data.data;
                // console.log(images);
                jQuery.each(images, function(index, value) {

                    jQuery("#left-dall-e-image").css("display", "block");
                    appendImage = '<div class="img-info">' +
                        '<div class="input-data check-box-row">' +
                        '<img src="' + value.url + '" alt="img-1">' +
                        '<div class="save-cta-info search-cta-info">' +
                        '<a download="download.jpg" href="' + value.url + '" title="ImageName" target="_blank">' +
                        'Download' +
                        '</div></a>' +
                        '</div>';
                    jQuery("#show-image-generator-dall-e").append(appendImage);
                });
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);


            } else if (response.result == 'Failure') {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                alert("Something Went Wrong!!")
            }

        }).fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 400) {
                // Status code 400 indicates a client-side error (Bad Request)
                // The response JSON data can be accessed using the responseJSON property
                var errorMessage = jqXHR.responseJSON.message;
                alert('API Error: ' + errorMessage);
            } else {
                // For other errors, you can display the generic error message
                alert('API Error: ' + errorThrown);
            }
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
        });
    })
</script>

<script>
    jQuery("#GenerateStable").click(function() {
        var prompt = jQuery("#StableDiffusionTextValue").val();
        var size = jQuery("#image-size-stable-diffusion").val();
        var n = parseInt(jQuery("#image-n-stable-diffusion").val());
        var openAiKey = "<?php echo esc_attr($openAi); ?>";
        var secretiKey = "<?php echo esc_attr($secertkey); ?>";
        if (prompt == '') {
            alert("Enter Image Title");
            return false;
        }
        if (openAiKey == '') {
            alert("OpenAi Key missing");
            return false;
        }
        if (secretiKey == '') {
            alert("Secret Key missing");
            return false;
        }
        jQuery('#show-image-generator-stable-e').empty();
        jQuery(".loaderoverlay").fadeIn(300);
        jQuery.ajax({
            url: "<?php echo esc_attr($apiUrl); ?>generate-image",
            type: 'POST',
            beforeSend: function(xhr) {
                xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
            },
            dataType: 'json',
            data: {
                'prompt': prompt,
                'n': n,
                'size': size
            }
        }).done(function(response) {

            if (response.result == 'Success') {
                var images = response.data.data;
                // console.log(images);
                jQuery.each(images, function(index, value) {

                    jQuery("#left-stable-e-image").css("display", "block");
                    appendImage = '<div class="img-info">' +
                        '<div class="input-data check-box-row">' +
                        '<img src="' + value.url + '" alt="img-1">' +
                        '<div class="save-cta-info search-cta-info">' +
                        '<a download="download.jpg" href="' + value.url + '" title="ImageName" target="_blank">' +
                        'Download' +
                        '</div></a>' +
                        '</div>';
                    jQuery("#show-image-generator-stable-e").append(appendImage);
                });
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);


            } else if (response.result == 'Failure') {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                alert("Something Went Wrong!!")
            }

        }).fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 400) {
                // Status code 400 indicates a client-side error (Bad Request)
                // The response JSON data can be accessed using the responseJSON property
                var errorMessage = jqXHR.responseJSON.message;
                alert('API Error: ' + errorMessage);
            } else {
                // For other errors, you can display the generic error message
                alert('API Error: ' + errorThrown);
            }
            setTimeout(function() {
                jQuery(".loaderoverlay").fadeOut(300);
            }, 500);
        });
    })
</script>