<div class="loaderoverlay">
    <div class="loader-cv-spinner">
        <span class="loader-spinner"></span>
    </div>
</div>


<!-- Google fonts -->



<div class="plugins-accounts-wrapper language-converter-ui-wrapper">
    <div class="top-header">
        <h1>Language Converter</h1>
        
    </div>


    <div class="plugins-accounts-info">
        <div class="left-sec-wrap">
            <div class="logo-info">
                <div class="icon-info"><?php echo $iWhitelogo; ?></div>
            </div>
            <ul>
                <li><a href="javascript:void(0)" class="menu-link-info active" data-target="tabs-1">Language Converter</a></li>
                <!-- <li><a href="#" class="menu-link-info" data-target="tabs-2">Logs</a></li> -->

            </ul>
        </div>
        <div class="right-sec-wrap">
            <div class="main-content-wrap">
                <div class="main-content-info tabs active" data-tab="tabs-1">
                    <h3>Language Converter</h3>
                    <div class="content-area-info">
                        <div class="left-data-info">
                            <div class="input-data">
                                <div class="label-info"><span>Choose Language:</span></div>
                                <div class="input-info">
                                    <select id="language">
                                        <?php
                                        foreach ($languageDataArray as $languageDataArraykey => $languageDataArrayValue) {
                                            $selected = ($languageDataArrayValue['language_code'] == 'english') ? 'selected' : '';
                                            echo "<option value='" . $languageDataArrayValue['language_code'] . "' $selected >" . $languageDataArrayValue['language'] . "</option>";
                                            // echo "<option value='" . esc_attr($languageDataArrayValue['language_code'])  . esc_attr($selected) . ">" . esc_html($languageDataArrayValue['language']) . "</option>";
                                        }
                                        ?>
                                    </select>
                                </div>
                            </div>
                            <div class="full-wid input-data">
                                <div class="input-info">
                                    <span>Text:</span>
                                    <input type="hidden" id="aih_language_nonce" value="<?php echo esc_attr(my_plugin_generate_nonce('aih_language_nonce')); ?>">
                                    <input type="text" id="preview_title" placholder="Enter title">
                                    <div class="sub-cta-info">
                                        <button id="generateLanguage" class="btn sub-cta-info">Convert Langugae</button>
                                    </div>

                                </div>
                            </div>


                            <div class="editor-data-wrap">
                                <div class="content-info">

                                    <span>Output:</span>
                                    <!-- <textarea id="output-langugae-translation" name="" rows="5" cols="20"></textarea> -->

                                    <?php
                                        $custom_text_value = '';
                                        wp_editor(
                                            $custom_text_value,
                                            'output-langugae-translation',  //Editor_ID
                                            array(
                                                'textarea_name' => '_wporg_preview_texarea',
                                                'editor_height' => 300,
                                                'media_buttons' => true,
                                                'wpautop' => false,
                                                'quicktags' => true,
                                                'tinymce' => true, // Textarea box// Textarea box
                                                'textarea_class' => 'preview_textarea'
                                            )
                                        );
                                    ?>

                                </div>
                            </div>
                        </div>

                    </div>

                </div>

            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    jQuery('.menu-link-info').on('click', function(e) {
        e.preventDefault();
        jQuery('.menu-link-info').removeClass('active');
        jQuery(this).addClass('active');
        jQuery('.tabs').removeClass('active');
        var tabID = jQuery(this).attr('data-target');
        jQuery('.tabs[data-tab="' + tabID + '"]').addClass('active');
    });
</script>

<script>
    jQuery(document).ready(function() {
        jQuery("#generateLanguage").click(function() {

            var transalate_language = jQuery("#language").val();
            var text = jQuery("#preview_title").val();
            if (text == '') {
                alert('Text Field Not Empty');
                return false;
            }
            jQuery(".loaderoverlay").fadeIn(300);
            jQuery.ajax({
                url: "<?php echo esc_url($apiUrl); ?>language-converter",
                type: 'POST',
                beforeSend: function(xhr) {
                    xhr.setRequestHeader("secertkey", "<?php echo esc_attr($secertkey); ?>");
                    xhr.setRequestHeader("openai", "<?php echo esc_attr($openAi); ?>");
                },
                dataType: 'json',
                data: {
                    'transalate_language': transalate_language,
                    'text': text
                }
            }).done(function(response) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                if (response.result == 'Success') {
                    // jQuery("#output-langugae-translation").val(response.data.choices[0].text);
                    var editorID = 'output-langugae-translation';
                    var editor = tinyMCE.get(editorID);
                    if (editor) {
                        editor.setContent(response.data.choices[0].text);
                    }

                    //tinymce.get("textarea-input-translate-language").setContent(response.data.choices[0].text);
                    var data = {
                        'action': 'aih_language_content',
                        'aih_language_nonce': jQuery('#aih_language_nonce').val(),
                        'language': transalate_language,
                        'text': text,
                        'translation': response.data.choices[0].text,
                        'date': response.data.created,
                        'token': response.data.usage.total_tokens,
                        'model': response.data.model
                    };
                    jQuery.post(ajaxurl, data, function(response) {
                        var responseJsonData = jQuery.parseJSON(response);
                        // console.log(responseJsonData.result);
                        if (responseJsonData.result == 'Success') {
                            // alert("Log saved successfully.");
                        } else if (responseJsonData.result == 'Failure') {
                            alert("Something Went Wrong!!");
                        }
                    });
                } else if (response.result == 'Failure') {
                    alert("Something Went Wrong!!")
                }
            }).fail(function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status === 400) {
                    // Status code 400 indicates a client-side error (Bad Request)
                    // The response JSON data can be accessed using the responseJSON property
                    var errorMessage = jqXHR.responseJSON.message;
                    alert('API Error: ' + errorMessage);
                } else {
                    // For other errors, you can display the generic error message
                    alert('API Error: ' + errorThrown);
                }
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
            });
        });
    });

    jQuery(document).ready(function() {
        jQuery('#logs-tab').click(function() {
            jQuery(".loaderoverlay").fadeIn(300);
            jQuery('table tbody > tr').remove();
            var data = {
                'action': 'aih_language_data_get',
            };
            jQuery.post(ajaxurl, data, function(response) {
                setTimeout(function() {
                    jQuery(".loaderoverlay").fadeOut(300);
                }, 500);
                var responseJsonData = jQuery.parseJSON(response);
                // console.log(responseJsonData.result);
                if (responseJsonData.result == 'Success') {
                    var table = '';
                    table += '<tbody>';
                    var dataObj = responseJsonData.data;
                    console.log(dataObj);
                    jQuery.each(dataObj, function(key2, valueObj) {
                        table += "<tr>";
                        jQuery.each(valueObj, function(key, value) {
                            table += "<td>" + value + "</td>"
                        });
                        table += "</tr>";
                    });
                    table += '</table>';
                    // console.log(table);
                    jQuery('.log-audio-table').append(table);
                } else if (responseJsonData.result == 'Failure') {
                    // alert("Something Went Wrong!!");
                }
            });
        })
    })
</script>